/* Client per richiedere l'estratto conto (versione 1) */

#include<stdio.h>
#include<fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#define DIM_BUFF 100


main(int argc, char *argv[])
{
int sd, nread, numcc, fromlen, conn_ok, num, i;
char buff[DIM_BUFF], c;
struct hostent *host;    
struct sockaddr_in servaddr; 
char ok[5];


/* CONTROLLO ARGOMENTI --------------------------------------- */
if(argc!=2) 
 { 
  printf("Error:%s server\n", argv[0]);
  exit(1);
 }


/* PREPARAZIONE INDIRIZZO SERVER ----------------------------- */
memset((char *)&servaddr, 0, sizeof(struct sockaddr_in));
servaddr.sin_family = AF_INET;
 
host = gethostbyname(argv[1]);
if (host == NULL) 
{
 printf("%s not found in /etc/hosts\n", argv[1]);  
 exit(1);
}

servaddr.sin_addr.s_addr=((struct in_addr*) (host->h_addr))->s_addr;
servaddr.sin_port = htons(12345); 


/* CREAZIONE E CONNESSIONE SOCKET ---------------------------- */
sd=socket(AF_INET, SOCK_STREAM, 0);
printf("Client estratto conto: creata la socket sd=%d\n", sd);

conn_ok=connect(sd,(struct sockaddr *) &servaddr, sizeof(struct sockaddr));
if(conn_ok<0) 
{ perror("Errore in connect"); exit(1);}
printf("Client estratto conto: connect ok\n");


/* CORPO DEL CLIENT:
/* ciclo di accettazione di richieste di estratto conto ------- */

printf("Richieste di estratti conto fino alla fine del file di input\n");
printf("Qualsiasi tasto per procedere, EOF per terminare: ");

while (gets(ok))
{

  printf("Numero di contocorrente: ");
  while (scanf("%i", &num) != 1)
  { 
    do
   	{c=getchar(); printf("%c ", c);} 
    while (c!= '\n'); 
    printf("Numero di contocorrente: ");
  }
  numcc=htonl(num);
  gets(ok);  

  if (write(sd,&numcc,4)<0)
  	{perror("write"); exit(1);}
  printf("Richiesta di estratto del cc n.%i inviata... \n", ntohl(numcc));

  if (read(sd, ok, 1)<0) 
	{perror("read"); exit(1);}
	
 if (ok[0]=='S')
  { 
   printf("ESTRATTO CONTO DEL CC N. %i:\n", num);
   while((nread=read(sd,&c,1))>0) 
      if (c!='\0'){
	write(1,&c,1);
	} else break;
  }
 else if (ok[0]=='N')printf("Numero di conto inesistente\n");
	else if (ok[0]=='B')printf("Nessuna movimentazione sul conto richiesto\n");

 printf("Qualsiasi tasto per procedere, EOF per terminare: ");
}//while

printf("Client estratto conto: termino...");
close(sd); 
exit(0);

}

