/* Client per richiedere l'estratto conto (versione 2)*/

#include<stdio.h>
#include<fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#define DIM_BUFF 100


main(int argc, char *argv[])
{
int sd, nread, numcc, fromlen, conn_ok, num, i;
char buff[DIM_BUFF], c;
const int on = 1;
struct hostent *host;    
struct sockaddr_in servaddr; 
char ok[5];


/* CONTROLLO ARGOMENTI --------------------------------------- */
if(argc!=2) 
 { 
  printf("Error:%s server\n", argv[0]);
  exit(1);
 }


/* PREPARAZIONE INDIRIZZO SERVER ----------------------------- */
memset((char *)&servaddr, 0, sizeof(struct sockaddr_in));
servaddr.sin_family = AF_INET;
 
host = gethostbyname(argv[1]);
if (host == NULL) 
{
 printf("%s not found in /etc/hosts\n", argv[1]);  
 exit(1);
}

servaddr.sin_addr.s_addr=((struct in_addr*) (host->h_addr))->s_addr;
servaddr.sin_port = htons(12345); 


/* CORPO DEL CLIENT:
/* ciclo di accettazione di richieste di estratto conto ------- */

printf("Richieste di estratti conto fino alla fine del file di input\n");
printf("Qualsiasi tasto per procedere, EOF per terminare: ");

while (gets(ok))
{
  /* CREAZIONE E CONNESSIONE SOCKET ---------------------------- */
  /* in questo schema  necessario ripetere creazione, settaggio opzioni e connect */
  /* ad ogni ciclo, perch il client fa una nuova connect ad ogni ciclo */
  sd=socket(AF_INET, SOCK_STREAM, 0);
  printf("Client estratto conto: creata la socket sd=%d\n", sd);
  if(setsockopt(sd, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on))<0)
	{perror("set opzioni socket TCP"); exit(1);}
  printf("Client estratto conto: set opzioni socket ok\n");
  conn_ok=connect(sd,(struct sockaddr *) &servaddr, sizeof(struct sockaddr));
  if(conn_ok<0) 
    { perror("Errore in connect"); exit(1);}
  printf("Client estratto conto: connect ok\n");


  printf("Numero di contocorrente: ");
  while (scanf("%i", &num) != 1)
  { 
    do
   	{c=getchar(); printf("%c ", c);} 
    while (c!= '\n'); 
    printf("Numero di contocorrente: ");
  }
  numcc=htonl(num);
  gets(ok);  

  if (write(sd,&numcc,4)<0)
  	{perror("write"); exit(1);}
  printf("Richiesta di estratto del cc n.%i inviata... \n", ntohl(numcc));

  /* il numero viaggia correttamente??
     e viene interpretato correttamente */
  
  if (read(sd, ok, 1)<0) 
	{perror("read"); exit(1);}
	
 
if (ok[0]=='S')
  { 
   printf("ESTRATTO CONTO DEL CC N. %i:\n", num);
   while((nread=read(sd,buff,DIM_BUFF))>0)
	write(1,buff,nread);
   }
   else if (ok[0]=='N')printf("Numero di conto inesistente\n");
	else if (ok[0]=='B')printf("Nessuna movimentazione sul conto richiesto\n");
 
 close(sd); // chiudo qua perch faccio una nuova connect ad ogni ciclo...
 printf("Qualsiasi tasto per procedere, EOF per terminare: ");

}//while


printf("Client estratto conto: termino...");
exit(0);

}

