/* Client per richiedere movimenti sul conto corrente */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>


main(int argc, char **argv)
{ 
struct hostent *host;	
struct sockaddr_in servaddr; 
int  sd, i, num, imp, len;
char ok[5], ris[10];
char nl, c;

typedef struct {
	int numcc;
	int impOp;
	char tipoOp;
} Request;

Request* req = (Request*)malloc(sizeof(Request));


/* CONTROLLO ARGOMENTI --------------------------------------- */
if(argc!=2) { 
	printf("Error:%s server\n", argv[0]);
	exit(1);
 }


/* PREPARAZIONE INDIRIZZO SERVER ----------------------------- */

memset((char *)&servaddr, 0, sizeof(struct sockaddr_in));

servaddr.sin_family = AF_INET;
host = gethostbyname (argv[1]);
if (host == NULL) 
{ printf("%s not found in /etc/hosts\n", argv[1]);
  exit(2);
} else 
{
  servaddr.sin_addr.s_addr=((struct in_addr *)(host->h_addr))->s_addr;
  servaddr.sin_port = htons(12346);
}


/* CREAZIONE E CONNESSIONE SOCKET ---------------------------- */
sd=socket(AF_INET, SOCK_DGRAM, 0);
if(sd<0) {perror("apertura socket"); exit(1);}
printf("Client: creata la socket sd=%d\n", sd);


/* CORPO DEL CLIENT:
/* ciclo di accettazione di richieste di estratto conto ------- */

printf("Richieste di movimenti fino alla fine del file di input\n");
printf("Qualsiasi tasto per procedere, EOF per terminare: ");


while (gets(ok))
{ 
  /* lettura dei dati da inviare */
  printf("Numero di contocorrente: ");
  while (scanf("%i", &num) != 1)
  { 
    do
   	{c=getchar(); printf("%c ", c);} 
   	while (c!= '\n'); 
    printf("Numero di contocorrente: ");
  }
  
  req->numcc=htonl(num);
  gets(ok);  

  do{
  printf("Operazione (V=versamento, P=prelievo): ");
  c = getchar();
  }
  while (c!='P' && c !='V');
  
  req->tipoOp=c; 

  printf("Importo: ");
  while (scanf("%i", &imp) != 1)
  { 
	do
   	  {c=getchar(); printf("%c ", c);} 
     	while (c!= '\n'); 
    printf("Importo: ");
  }
  req->impOp=htonl(imp);
 


/* lettura completata */
  printf("Operazione richiesta: %c di %i  sul cc n. %i \n", 
    req->tipoOp, ntohl(req->impOp), ntohl(req->numcc));

/* richiesta movimento */
  len=sizeof(servaddr);
  i= sendto(sd, req, sizeof(Request), 0, (struct sockaddr *)&servaddr, len);
  if(i<0) {perror("scrittura socket"); exit(1);}
  

  /* ricezione del risultato */
  printf("Attesa del risultato...\n"); 
  if (recvfrom(sd, ris, sizeof(ris), 0, (struct sockaddr *)&servaddr, &len)<0) 
	{perror("recvfrom"); exit(1);}
  printf("Esito dell'operazione: %s\n", ris);

  printf("Qualsiasi tasto per procedere, EOF per terminare: ");

} // while



printf("Client movimenti: termino...");
close(sd);
exit(0);
}
